/* Generated from "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod" by precompile.pike
 *
 * Do NOT edit this file.
 */

#undef PRECOMPILE_API_VERSION
#define PRECOMPILE_API_VERSION 4



#undef cmod___CMOD__
#define cmod___CMOD__ 1
#line 1 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
/* vim:syntax=c
 */
/* -*- c -*-
|| This file is part of Pike. For copyright information see COPYRIGHT.
|| Pike is distributed under GPL, LGPL and MPL. See the file COPYING
|| for more information.
*/

/* Module for the linux inotify api.
 *
 * Ref: inotify(7)
 *
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include "global.h"
#include "interpret.h"
#include "module.h"
#include "program.h"
#include "stralloc.h"
#include "svalue.h"
#include "object.h"
#include "pike_types.h"
#include "builtin_functions.h"

#ifdef HAVE_SYS_INOTIFY_H

#include <sys/inotify.h>
#include <errno.h>



#ifndef TYPEOF
/* Compat with older Pikes. */
#define TYPEOF(SVAL)	((SVAL).type)
#define SUBTYPEOF(SVAL)	((SVAL).subtype)
#define SET_SVAL_TYPE(SVAL, TYPE)	(TYPEOF(SVAL) = TYPE)
#define SET_SVAL_SUBTYPE(SVAL, TYPE)	(SUBTYPEOF(SVAL) = TYPE)
#define SET_SVAL(SVAL, TYPE, SUBTYPE, FIELD, EXPR) do {	\
    /* Set the type afterwards to avoid a clobbered	\
     * svalue in case EXPR throws. */			\
    (SVAL).u.FIELD = (EXPR);				\
    SET_SVAL_TYPE((SVAL), (TYPE));			\
    SET_SVAL_SUBTYPE((SVAL), (SUBTYPE));		\
  } while(0)
#endif /* !TYPEOF */


#ifndef DEFAULT_CMOD_STORAGE
#define DEFAULT_CMOD_STORAGE
#endif
/*! @module System */

/*! @module Inotify
 *! This module implements an API to linux inotify. It is available on all
 *! kernels from version 2.6.13 onwards. Inotify offers fast and scalable file
 *! notifications.
 */

/*! @decl constant IN_ALL_EVENTS
 *! This is a derived constant that is not part of the standard inotify API. It
 *! is the union of all other constants.
 *!
 *! @decl constant IN_ACCESS
 *! @decl constant IN_ATTRIB
 *! @decl constant IN_CLOSE
 *! @decl constant IN_CLOSE_WRITE
 *! @decl constant IN_CLOSE_NOWRITE
 *! @decl constant IN_CREATE
 *! @decl constant IN_DELETE
 *! @decl constant IN_DELETE_SELF
 *! @decl constant IN_MODIFY
 *! @decl constant IN_MOVE_SELF
 *! @decl constant IN_MOVED_FROM
 *! @decl constant IN_MOVED_TO
 *! @decl constant IN_OPEN
 *! @decl constant IN_MOVE
 *! @decl constant IN_CLOSE
 *! @decl constant IN_DONT_FOLLOW
 *! @decl constant IN_MASK_ADD
 *! @decl constant IN_ONESHOT
 *! @decl constant IN_ONLYDIR
 *! @decl constant IN_IGNORED
 *! @decl constant IN_ISDIR
 *! @decl constant IN_Q_OVERFLOW
 *! @decl constant IN_UNMOUNT
 *! 	Please have a look at the inotify(7) manpage for information about
 *!	these constants.
 *! @note
 *! 	Some constants may not be available when the module has been
 *!	compiled on a machine with linux kernel before 2.6.15. See the
 *!	manpage for more details.
 */

/*! @decl array(string|int) parse_event(string data)
 *! Parses one inotify_event struct from @expr{data@}.
 *! @returns
 *! 	Returns an array consisting of
 *! 	@array
 *!	    @elem int 0
 *! 		The watch descriptor returned by @[_Instance()->add_watch()]
 *!		when the watch for this file was added.
 *!	    @elem int 1
 *! 		An integer that describes the event that occured. See
 *!		the inotify manpage for a list of possible events and
 *!		their numerical identifiers.
 *!	    @elem int 2
 *! 		An integer cookie that can be used to group together
 *!		different events that were triggered by moving a file
 *!		from one location to another.
 *! 	    @elem string 3
 *! 		The name of the file. This will only be present if the
 *!		event happened to a file in a directory that was
 *!		watched, e.g. with @[System.Inotify.IN_CREATE].
 *! 		Otherwise this will be 0.
 *!	    @elem int 4
 *! 		The length of the data that has been parsed. If the @[data]
 *!		string contains more than one inotify event, this parse
 *!		function needs to be called again with the remainder as
 *!		an argument.
 *! 	@endarray
 */
#define f_parse_event_defined
DEFAULT_CMOD_STORAGE ptrdiff_t f_parse_event_fun_num = 0;
DEFAULT_CMOD_STORAGE void f_parse_event(INT32 args) {
#line 107 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
struct pike_string * data;
#line 107 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(args != 1) wrong_number_of_args_error("parse_event",args,1);
#line 107 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(TYPEOF(Pike_sp[0-1]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("parse_event",1,"string");
#line 107 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
debug_malloc_pass(data=Pike_sp[0-1].u.string);
#line 107 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
{
    struct inotify_event * event;
    size_t len;

    if (data->size_shift)
	Pike_error("Inotify events should not be wide.\n");

    if ((size_t)data->len < sizeof(struct inotify_event))
	Pike_error("Malformed data.\n");

    event = (struct inotify_event *)data->str;
    pop_n_elems(args);

    if (event->len > data->len - sizeof(struct inotify_event))
	Pike_error("Data missing.\n");

    push_int((int)event->wd);
    push_int((int)event->mask);
    push_int((int)event->cookie);

    if (event->len && (len = strlen(event->name)))
	push_string(make_shared_binary_string(event->name, len));
    else
	push_int(0);

    push_int((int)(event->len + sizeof(struct inotify_event)));

    f_aggregate(5);
}

}
/*! @class _Instance
 *! 	Simple wrapper class that gives direct access to the @tt{inotify(7)@}
 *!	interface. On create an inotify instance is initiated by calling
 *!	@tt{inotify_init(2)@}. Every object of this class has its own inotify
 *!	file descriptor. Use this class only if you want direct access to
 *!	the file descriptor to read from it manually. For a more user
 *!	friendly inferface use @[System.Inotify.Instance].
 *!
 *! @seealso
 *!     @[System.Inotify.Instance]
 */

#undef class_cq__Instance_defined
#define class_cq__Instance_defined
DEFAULT_CMOD_STORAGE struct program *cq__Instance_program=NULL;
static int cq__Instance_program_fun_num=-1;

#undef var_fd_cq__Instance_defined
#define var_fd_cq__Instance_defined

#undef THIS
#define THIS ((struct cq__Instance_struct *)(Pike_interpreter.frame_pointer->current_storage))

#undef THIS_CQ__INSTANCE
#define THIS_CQ__INSTANCE ((struct cq__Instance_struct *)(Pike_interpreter.frame_pointer->current_storage))

#undef OBJ2_CQ__INSTANCE
#define OBJ2_CQ__INSTANCE(o) ((struct cq__Instance_struct *)(o->storage+cq__Instance_storage_offset))

#undef GET_CQ__INSTANCE_STORAGE
#define GET_CQ__INSTANCE_STORAGE(o) ((struct cq__Instance_struct *)(o->storage+cq__Instance_storage_offset)
static ptrdiff_t cq__Instance_storage_offset;
struct cq__Instance_struct {

#ifdef var_fd_cq__Instance_defined
#line 149 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
int fd;
#endif /* var_fd_cq__Instance_defined */
};
#ifdef PIKE_DEBUG
/* Ensure the struct is used in a variable declaration, or else gdb might not see it. */
static struct cq__Instance_struct *cq__Instance_gdb_dummy_ptr;
#endif
/*! @decl int add_watch(string file, int mask)
     *! Add a watch for a certain file or directory and specific events.
     *! Adding more than one watch for one file will overwrite the
     *! previous watch unless @[System.Inotify.IN_MASK_ADD] is contained
     *! in the mask.
     *! @param path
     *!	    Path of the file or directory.
     *! @param mask
     *!	    Integer mask specifying the event type. This can be a
     *!	    combination of different event types using bitwise OR.
     *!	    See the inotify manpage for possible values and their
     *!	    description. The values defined by the inotify header
     *!	    file are exported by @[System.Inotify] as constants
     *!	    using the same names (e.g. @[System.Inotify.IN_CREATE]).
     *! @returns
     *!     Returns a watch descriptor.
     *! @note
     *!	    Subdirectories are not watched. If you want to watch
     *!	    subdirectories as well, you need to add watches for
     *!	    them individually.
     *!
     *! @seealso
     *!     @[rm_watch()], @[parse_event()]
     */
    #define f_cq__Instance_add_watch_defined
DEFAULT_CMOD_STORAGE ptrdiff_t f_cq__Instance_add_watch_fun_num = 0;
DEFAULT_CMOD_STORAGE void f_cq__Instance_add_watch(INT32 args) {
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
struct pike_string * file;
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
INT_TYPE mask;
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(args != 2) wrong_number_of_args_error("add_watch",args,2);
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(TYPEOF(Pike_sp[0-2]) != PIKE_T_STRING) SIMPLE_ARG_TYPE_ERROR("add_watch",1,"string");
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
debug_malloc_pass(file=Pike_sp[0-2].u.string);
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(TYPEOF(Pike_sp[1-2]) != PIKE_T_INT) SIMPLE_ARG_TYPE_ERROR("add_watch",2,"int");
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
mask=Pike_sp[1-2].u.integer;
#line 175 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
{
	INT32 err;

	if (file->size_shift)
	    Pike_error("Widestring filenames are not allowed.\n");

	err = inotify_add_watch(THIS->fd, file->str, (INT32)mask);

	if (err == -1)
	    Pike_error("inotify_add_watch failed: %s\n",
		       strerror(errno));
	else
	    do { INT_TYPE ret_=(err); pop_n_elems(2); push_int(ret_); return; }while(0);
#line 188 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
}

    }
/*! @decl int get_fd()
     *! @returns
     *!	    Returns the file descriptor that is associated to the inotify
     *!	    instance.
     */
    #define f_cq__Instance_get_fd_defined
DEFAULT_CMOD_STORAGE ptrdiff_t f_cq__Instance_get_fd_fun_num = 0;
DEFAULT_CMOD_STORAGE void f_cq__Instance_get_fd(INT32 args) {
#line 195 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(args != 0) wrong_number_of_args_error("get_fd",args,0);
#line 195 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
{
	do { INT_TYPE ret_=(THIS->fd);  push_int(ret_); return; }while(0);
#line 197 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
}

    }
/*! @decl int rm_watch(int wd)
     *! Remove a watch.
     *! @param wd
     *!	    The watch descriptor that was returned by @[add_watch()].
     */
    #define f_cq__Instance_rm_watch_defined
DEFAULT_CMOD_STORAGE ptrdiff_t f_cq__Instance_rm_watch_fun_num = 0;
DEFAULT_CMOD_STORAGE void f_cq__Instance_rm_watch(INT32 args) {
#line 204 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
INT_TYPE wd;
#line 204 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(args != 1) wrong_number_of_args_error("rm_watch",args,1);
#line 204 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
if(TYPEOF(Pike_sp[0-1]) != PIKE_T_INT) SIMPLE_ARG_TYPE_ERROR("rm_watch",1,"int");
#line 204 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
wd=Pike_sp[0-1].u.integer;
#line 204 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
{
	INT32 err;

	err = inotify_rm_watch(THIS->fd, wd);

	if (err == 0) {
	    return;
	}

	if (errno == EINVAL) {
	    Pike_error("Wrong argument to rm_watch().\n");
	} else if (errno == EBADF) {
	    Pike_error("Oups. I feel funny inside.\n");
	}
    }

    }

#undef internal_init_cq__Instance_defined
#define internal_init_cq__Instance_defined

#undef cq__Instance_event_handler_defined
#define cq__Instance_event_handler_defined
static void init_cq__Instance_struct(void)
#line 220 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
{
	THIS->fd = inotify_init();

	if (THIS->fd == -1) switch (errno) {
	case EMFILE:
	    Pike_error("User limit on inotify instances reached.\n");
	case ENFILE:
	    Pike_error("User limit on file descriptors reached.\n");
	case ENOMEM: Pike_error("No free kernel memory available.\n");
	}
    }

    
#undef cq__Instance_gc_live_obj
#define cq__Instance_gc_live_obj

#undef internal_exit_cq__Instance_defined
#define internal_exit_cq__Instance_defined

#undef cq__Instance_event_handler_defined
#define cq__Instance_event_handler_defined
static void exit_cq__Instance_struct(void)
#line 232 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
{
	close(THIS->fd);
    }

#ifdef cq__Instance_event_handler_defined
static void cq__Instance_event_handler(int ev) {
  switch(ev) {

#ifdef internal_init_cq__Instance_defined
  case PROG_EVENT_INIT: init_cq__Instance_struct(); break;

#endif /* internal_init_cq__Instance_defined */

#ifdef internal_exit_cq__Instance_defined
  case PROG_EVENT_EXIT: exit_cq__Instance_struct(); break;

#endif /* internal_exit_cq__Instance_defined */
  default: break; 
  }
}

#endif /* cq__Instance_event_handler_defined */
/*! @endclass
 */

#line 240 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
#define ADD_ICONST(name) do {			\
    add_integer_constant(#name, name, 0);	\
} while(0);

#else /* !HAVE_SYS_INOTIFY_H */

#define ADD_ICONST(name)

#endif /* HAVE_SYS_INOTIFY_H */

PIKE_MODULE_INIT {
    ADD_ICONST(IN_ACCESS);
    ADD_ICONST(IN_ALL_EVENTS);
    ADD_ICONST(IN_ATTRIB);
    ADD_ICONST(IN_CLOSE_WRITE);
    ADD_ICONST(IN_CLOSE_NOWRITE);
    ADD_ICONST(IN_CREATE);
    ADD_ICONST(IN_DELETE);
    ADD_ICONST(IN_DELETE_SELF);
    ADD_ICONST(IN_MODIFY);
    ADD_ICONST(IN_MOVE_SELF);
    ADD_ICONST(IN_MOVED_FROM);
    ADD_ICONST(IN_MOVED_TO);
    ADD_ICONST(IN_OPEN);

    ADD_ICONST(IN_MOVE);
    ADD_ICONST(IN_CLOSE);

/* some of these came with 2.6.15 linux and 2.5 glibc */
#ifdef IN_DONT_FOLLOW
    ADD_ICONST(IN_DONT_FOLLOW);
#endif
#ifdef IN_MASK_ADD
    ADD_ICONST(IN_MASK_ADD);
#endif
    ADD_ICONST(IN_ONESHOT);
#ifdef IN_ONLYDIR
    ADD_ICONST(IN_ONLYDIR);
#endif

    ADD_ICONST(IN_IGNORED);
    ADD_ICONST(IN_ISDIR);
    ADD_ICONST(IN_Q_OVERFLOW);
    ADD_ICONST(IN_UNMOUNT);

    
#ifdef class_cq__Instance_defined

#ifdef PROG_CQ__INSTANCE_ID
#line 148 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
  START_NEW_PROGRAM_ID(CQ__INSTANCE);
#else
#line 148 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
  start_new_program();

#endif /* PROG_CQ__INSTANCE_ID */

#ifndef tObjImpl_CQ__INSTANCE

#undef tObjImpl_CQ__INSTANCE
#define tObjImpl_CQ__INSTANCE tObj

#endif /* tObjImpl_CQ__INSTANCE */

#ifdef THIS_CQ__INSTANCE
  cq__Instance_storage_offset = ADD_STORAGE(struct cq__Instance_struct);
#endif /* THIS_CQ__INSTANCE */

#ifdef cq__Instance_event_handler_defined
  pike_set_prog_event_callback(cq__Instance_event_handler);

#ifndef cq__Instance_gc_live_obj
  Pike_compiler->new_program->flags &= ~PROGRAM_LIVE_OBJ;

#endif /* cq__Instance_gc_live_obj */

#endif /* cq__Instance_event_handler_defined */

#ifdef f_cq__Instance_add_watch_defined
  f_cq__Instance_add_watch_fun_num =
    ADD_FUNCTION2("add_watch", f_cq__Instance_add_watch, tFunc(tStr "\10\200\0\0\0\177\377\377\377","\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_cq__Instance_add_watch_defined */

#ifdef f_cq__Instance_get_fd_defined
  f_cq__Instance_get_fd_fun_num =
#line 195 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
    ADD_FUNCTION2("get_fd", f_cq__Instance_get_fd, tFunc(tNone,"\10\200\0\0\0\177\377\377\377"), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_cq__Instance_get_fd_defined */

#ifdef f_cq__Instance_rm_watch_defined
  f_cq__Instance_rm_watch_fun_num =
#line 204 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
    ADD_FUNCTION2("rm_watch", f_cq__Instance_rm_watch, tFunc("\10\200\0\0\0\177\377\377\377",tVoid), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_cq__Instance_rm_watch_defined */
#line 148 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
  cq__Instance_program=end_program();
#line 148 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
  cq__Instance_program_fun_num=add_program_constant("_Instance",cq__Instance_program,0);

#endif /* class_cq__Instance_defined */

#ifdef f_parse_event_defined
  f_parse_event_fun_num =
#line 107 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
    ADD_FUNCTION2("parse_event", f_parse_event, tFunc(tStr,tArr(tOr(tStr,"\10\200\0\0\0\177\377\377\377"))), 0, OPT_EXTERNAL_DEPEND|OPT_SIDE_EFFECT);

#endif /* f_parse_event_defined */
#line 286 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
}

PIKE_MODULE_EXIT {
    
#ifdef class_cq__Instance_defined
  if(cq__Instance_program) {
#line 148 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
    free_program(cq__Instance_program);
    cq__Instance_program=0;
  }

#endif /* class_cq__Instance_defined */
#line 290 "/Users/hww3/pike-git/src/modules/Inotify/inotify.cmod"
}

/*! @endmodule
 */
/*! @endmodule
 */

